/*
### refresh values of all main panel items ###
*/

#include <suntool/sunview.h>
#include <suntool/panel.h>
main_refresh()
{
	int i;
	extern short main_panel_show,window_size_panel_show,options_panel_show,system_info_panel_show,save_load_panel_show,section_panel_show;
	extern int more_digits_on,var_dim,func_dim,param_dim,full_dim;
	extern int param_dim,var_dim,mapping_on,draw_all,i_start,i_max,i_step,cur_color,n_poincare;
	extern int n_stored_data0,n_stored_data1,n_displayed_data1,n_displayed_data0;
	extern int var_cur_index[],param_cur_index[];
	extern double colorcode_min,colorcode_max,section_constant;
	extern double time_step,average_return_time,*func_i,*func_f;
	extern double *param,*win_var_i,*all_min,*all_max;
	extern char string[],dir_name[],file_name[];

	extern Panel_item *param_item,*var_i_item,*all_min_item,*all_max_item;
	extern Panel_item time_step_item,average_return_time_item,*func_i_item,*func_f_item;
	extern Panel_item i_start_item,i_max_item,i_step_item;
	extern Panel_item n_poincare_item,n_displayed_data0_item,n_displayed_data1_item;
	extern Panel_item proj_var_item[],proj_param_item[];
	extern Panel_item dir_name_item, file_name_item;
	extern Panel_item n_stored_data0_item,n_stored_data1_item,section_constant_item,colorcode_min_item,colorcode_max_item,cur_color_item;

	if(more_digits_on){
		if(main_panel_show){
			for (i = 0; i < param_dim; i++) {
				sprintf(string, "%.12lg", param[i]);
				panel_set_value(param_item[i], string);
			}
			for (i = 0; i < var_dim; i++) {
				sprintf(string, "%.12lg", win_var_i[i]);
				panel_set_value(var_i_item[i], string);
			}
		}
		if(window_size_panel_show){
			for (i = 0; i < full_dim+param_dim; i++) {
				sprintf(string, "%.12lg", all_min[i]);
				panel_set_value(all_min_item[i], string);
				sprintf(string, "%.12lg", all_max[i]);
				panel_set_value(all_max_item[i], string);
			}
		}
		if(system_info_panel_show){
			/* Refresh regardless of func_on. Maybe need a fix
			along with reset()  and create_system_info_p() */
			for (i = 0; i < func_dim; i++) {
				sprintf(string, "%.12lg", func_i[i]);
				panel_set_value(func_i_item[i], string);
				sprintf(string, "%.12lg", func_f[i]);
				panel_set_value(func_f_item[i], string);
			}
		}
	}
	else {
		if(main_panel_show){
			for (i = 0; i < param_dim; i++) {
				sprintf(string, "%lg", param[i]);
				panel_set_value(param_item[i], string);
			}
			for (i = 0; i < var_dim; i++) {
				sprintf(string, "%lg", win_var_i[i]);
				panel_set_value(var_i_item[i], string);
			}
		}
		if(window_size_panel_show){
			for (i = 0; i < full_dim+param_dim; i++) {
				sprintf(string, "%lg", all_min[i]);
				panel_set_value(all_min_item[i], string);
				sprintf(string, "%lg", all_max[i]);
				panel_set_value(all_max_item[i], string);
			}
		}
		if(system_info_panel_show){
			/* Refresh regardless of func_on. Maybe need a fix
			along with reset()  and create_system_info_p() */
			for (i = 0; i < func_dim; i++) {
				sprintf(string, "%lg", func_i[i]);
				panel_set_value(func_i_item[i], string);
				sprintf(string, "%lg", func_f[i]);
				panel_set_value(func_f_item[i], string);
			}
		}
	}
	if(main_panel_show){
		sprintf(string, "%d", i_start);
		panel_set_value(i_start_item, string);
		sprintf(string, "%d", i_max);
		panel_set_value(i_max_item, string);
		sprintf(string, "%d", i_step);
		panel_set_value(i_step_item, string);
		if(!mapping_on){
			sprintf(string, "%lg", time_step);
			panel_set_value(time_step_item, string);
		}
	}
	if(system_info_panel_show){
		sprintf(string, "%d", n_displayed_data1);
		panel_set_value(n_displayed_data1_item, string);
		sprintf(string, "%d", n_displayed_data0);
		panel_set_value(n_displayed_data0_item, string);
		if(!mapping_on && !draw_all){
			sprintf(string, "%lg", average_return_time);
			panel_set_value(average_return_time_item, string);
		}
	}
	if(window_size_panel_show){
		sprintf(string, "%d", n_stored_data1);
		panel_set_value(n_stored_data1_item, string);
		sprintf(string, "%d", n_stored_data0);
		panel_set_value(n_stored_data0_item, string);

		sprintf(string, "%d", param_cur_index[0]);
		panel_set_value(proj_param_item[0], string);
		sprintf(string, "%d", param_cur_index[1]);
		panel_set_value(proj_param_item[1], string);
		sprintf(string, "%d", var_cur_index[0]);
		panel_set_value(proj_var_item[0], string);
		sprintf(string, "%d", var_cur_index[1]);
		panel_set_value(proj_var_item[1], string);
	}


	if(save_load_panel_show){
		sprintf(string, "%s", file_name);
		panel_set_value(file_name_item, string);
		sprintf(string, "%s", dir_name);
		panel_set_value(dir_name_item, string);
	}

	if(options_panel_show){
		sprintf(string, "%lg", colorcode_min);
		panel_set_value(colorcode_min_item, string);
		sprintf(string, "%lg", colorcode_max);
		panel_set_value(colorcode_max_item, string);
		sprintf(string, "%d", cur_color);
		panel_set_value(cur_color_item, string);
	}

	if(section_panel_show){
		sprintf(string, "%d", n_poincare);
		panel_set_value(n_poincare_item, string);
		sprintf(string, "%lg",section_constant);
		panel_set_value(section_constant_item, string);
	}
}
